/*
 * generated_operator.h
 *
 *  Created on: 04.11.2015
 *      Author: Raphael Imahorn <raphael.imahorn@stud.unibas.ch>
 */

#ifndef GENERATED_OPERATOR_H_
#define GENERATED_OPERATOR_H_

#include "global_state.h"
#include "global_operator.h"

#include <vector>
#include <string>

class GeneratedOperator{
	    std::vector<int> preconditions;
	    std::vector<int> effects;
	    std::string name;
	    int cost;

	public:
	    GeneratedOperator(std::string name, const std::vector<int> &preconditions,
	    		const std::vector<int> &effects, int cost = 1);
	    ~GeneratedOperator() = default;
	    const std::string &get_name() const {return name;}

	    const std::vector<int> &get_preconditions() const {return preconditions;}
	    const std::vector<int> &get_effects() const {return effects;}

	    int get_cost() const {return cost;}

	    bool operator==(const GeneratedOperator &other) const {
	    	return cost == other.cost
	    			&& name == other.name
	    			&& preconditions == other.preconditions
	    			&& effects == other.effects;
	    }

	    bool operator!=(const GeneratedOperator &other) const {
	    	return !(*this == other);
	    }
};

#endif /* GENERATED_OPERATOR_H_ */
